"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getColumnProps = getColumnProps;
exports["default"] = Col;
exports.propTypes = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _util = require("../util");

var _types = require("../types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var propTypes = {
  xs: _propTypes["default"].oneOfType([_types.ColumnSizeType, _propTypes["default"].bool]),
  sm: _propTypes["default"].oneOfType([_types.ColumnSizeType, _propTypes["default"].bool]),
  md: _propTypes["default"].oneOfType([_types.ColumnSizeType, _propTypes["default"].bool]),
  lg: _propTypes["default"].oneOfType([_types.ColumnSizeType, _propTypes["default"].bool]),
  xl: _propTypes["default"].oneOfType([_types.ColumnSizeType, _propTypes["default"].bool]),
  xsOffset: _propTypes["default"].number,
  smOffset: _propTypes["default"].number,
  mdOffset: _propTypes["default"].number,
  lgOffset: _propTypes["default"].number,
  xlOffset: _propTypes["default"].number,
  first: _types.ViewportSizeType,
  last: _types.ViewportSizeType,
  initialOrder: _types.ViewportSizeType,
  hidden: _types.ViewportSizeType,
  className: _propTypes["default"].string,
  tagName: _propTypes["default"].string,
  children: _propTypes["default"].node
};
exports.propTypes = propTypes;
var classMap = {
  xs: "col-xs",
  sm: "col-sm",
  md: "col-md",
  lg: "col-lg",
  xl: "col-xl",
  xsOffset: "col-xs-offset",
  smOffset: "col-sm-offset",
  mdOffset: "col-md-offset",
  lgOffset: "col-lg-offset",
  xlOffset: "col-xl-offset"
};

function getColClassNames(props) {
  var extraClasses = [];

  if (props.className) {
    extraClasses.push(props.className);
  }

  if (props.first) {
    extraClasses.push((0, _util.getClass)("first-" + props.first));
  }

  if (props.last) {
    extraClasses.push((0, _util.getClass)("last-" + props.last));
  }

  if (props.initialOrder) {
    extraClasses.push((0, _util.getClass)("initial-order-" + props.initialOrder));
  }

  if (props.hidden) {
    extraClasses.push((0, _util.getClass)("hidden-" + props.hidden));
  }

  return Object.keys(props).filter(function (key) {
    return classMap[key];
  }).map(function (key) {
    return (0, _util.getClass)((0, _util.isInteger)(props[key]) ? classMap[key] + "-" + props[key] : classMap[key]);
  }).concat(extraClasses);
}

function getColumnProps(props) {
  return (0, _util.createProps)(propTypes, props, getColClassNames(props));
}

function Col(props) {
  var tagName = props.tagName,
      columnProps = _objectWithoutProperties(props, ["tagName"]);

  return _react["default"].createElement(tagName || "div", getColumnProps(columnProps));
}

Col.propTypes = propTypes;