"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRowProps = getRowProps;
exports["default"] = Row;
exports.propTypes = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _util = require("../util");

var _types = require("../types");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var rowKeys = ["start", "center", "end", "top", "middle", "bottom", "around", "between", "hidden"];
var propTypes = {
  reverse: _propTypes["default"].bool,
  start: _types.ViewportSizeType,
  center: _types.ViewportSizeType,
  end: _types.ViewportSizeType,
  top: _types.ViewportSizeType,
  middle: _types.ViewportSizeType,
  bottom: _types.ViewportSizeType,
  around: _types.ViewportSizeType,
  between: _types.ViewportSizeType,
  hidden: _types.ViewportSizeType,
  className: _propTypes["default"].string,
  tagName: _propTypes["default"].string,
  children: _propTypes["default"].node
};
exports.propTypes = propTypes;

function getRowClassNames(props) {
  var modificators = [props.className, (0, _util.getClass)("row")];

  for (var i = 0; i < rowKeys.length; ++i) {
    var key = rowKeys[i];
    var value = props[key];

    if (value) {
      modificators.push((0, _util.getClass)("".concat(key, "-").concat(value)));
    }
  }

  if (props.reverse) {
    modificators.push((0, _util.getClass)("reverse"));
  }

  return modificators;
}

function getRowProps(props) {
  return (0, _util.createProps)(propTypes, props, getRowClassNames(props));
}

function Row(props) {
  return _react["default"].createElement(props.tagName || "div", getRowProps(props));
}

Row.propTypes = propTypes;