"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getClass = getClass;
exports.createProps = createProps;
exports.isInteger = isInteger;

var _flexboxgrid = _interopRequireDefault(require("flexboxgrid2"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function getClass(className) {
  return _flexboxgrid["default"] && _flexboxgrid["default"][className] ? _flexboxgrid["default"][className] : className;
}

function createProps(propTypes, props, classNames) {
  var newProps = {};
  Object.keys(props).filter(function (key) {
    return key === "children" || !propTypes[key];
  }).forEach(function (key) {
    return newProps[key] = props[key];
  });
  var className = (0, _classnames["default"])(classNames);
  return Object.assign({}, newProps, {
    className: className
  });
}

function isInteger(value) {
  return typeof value === "number" && isFinite(value) && Math.floor(value) === value;
}